#include <string.h>
#include <stdint.h>

int _strlen(const char* inStr) {
	if(inStr == NULL)
		return 0;
	int i;
	for(i = 0; inStr[i] != '\0'; i++);
	return i;
}



char* strcpy(char* outDest, const char* inSrc) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; inSrc[i] != '\0'; i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}

char* strncpy(char* outDest, const char* inSrc, size_t inLength) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; (inSrc[i] != '\0') && (i < inLength); i++)
		outDest[i] = inSrc[i];
	outDest[i] = '\0';
	return outDest;
}

int strcmp(const char* inStr0, const char* inStr1) {
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];
	uintptr_t i;
	for(i = 0; (inStr0[i] != '\0') || (inStr1[i] != '\0'); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}

int strncmp(const char* inStr0, const char* inStr1, size_t inLength) {
	if(inStr0 == NULL) {
		if(inStr1 == NULL)
			return 0;
		return -inStr1[0];
	}
	if(inStr1 == NULL)
		return (unsigned char)inStr0[0];
	uintptr_t i;
	for(i = 0; (i < inLength) && ((inStr0[i] != '\0') || (inStr1[i] != '\0')); i++) {
		if(inStr0[i] != inStr1[i])
			return (inStr0[i] - inStr1[i]);
	}
	return 0;
}



void* memcpy(void* outDest, const void* inSrc, size_t inLength) {
	if((outDest == NULL) || (inSrc == NULL))
		return NULL;
	size_t i;
	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = ((uint8_t*)inSrc)[i];
	return outDest;
}

void* memset(void* outDest, int inValue, size_t inLength) {
	if(outDest == NULL)
		return NULL;
	if((inValue >= 256) || (inValue < -128))
		return NULL;
	size_t i;
	for(i = 0; i < inLength; i++)
		((uint8_t*)outDest)[i] = (uint8_t)inValue;
	return outDest;
}
